/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * BindVirtualVolumesRequest  
 * BindVirtualVolume binds a VVol with a Host.
 **/

public class BindVirtualVolumesRequest implements Serializable {

    public static final long serialVersionUID = -4148069295279337852L;
    @SerializedName("virtualVolumeIDs") private java.util.UUID[] virtualVolumeIDs;
    @SerializedName("virtualVolumeHostID") private java.util.UUID virtualVolumeHostID;
    @SerializedName("bindContext") private String bindContext;

    // empty constructor
    @Since("7.0")
    public BindVirtualVolumesRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public BindVirtualVolumesRequest(
        java.util.UUID[] virtualVolumeIDs,
        java.util.UUID virtualVolumeHostID,
        String bindContext
    )
    {
        this.virtualVolumeIDs = virtualVolumeIDs;
        this.virtualVolumeHostID = virtualVolumeHostID;
        this.bindContext = bindContext;
    }

    /** 
     * The UUID of the VVol to bind.
     **/
    public java.util.UUID[] getVirtualVolumeIDs() { return this.virtualVolumeIDs; }
    public void setVirtualVolumeIDs(java.util.UUID[] virtualVolumeIDs) { 
        this.virtualVolumeIDs = virtualVolumeIDs;
    }
    /** 
     * The UUID of the ESX host.
     **/
    public java.util.UUID getVirtualVolumeHostID() { return this.virtualVolumeHostID; }
    public void setVirtualVolumeHostID(java.util.UUID virtualVolumeHostID) { 
        this.virtualVolumeHostID = virtualVolumeHostID;
    }
    /** 
     * Normal or Start?
     **/
    public String getBindContext() { return this.bindContext; }
    public void setBindContext(String bindContext) { 
        this.bindContext = bindContext;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        BindVirtualVolumesRequest that = (BindVirtualVolumesRequest) o;

        return 
            Arrays.equals(virtualVolumeIDs, that.virtualVolumeIDs) && 
            Objects.equals(virtualVolumeHostID, that.virtualVolumeHostID) && 
            Objects.equals(bindContext, that.bindContext);
    }

    @Override
    public int hashCode() {
        return Objects.hash( (Object[])virtualVolumeIDs,virtualVolumeHostID,bindContext );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("virtualVolumeIDs", virtualVolumeIDs);
        map.put("virtualVolumeHostID", virtualVolumeHostID);
        map.put("bindContext", bindContext);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" virtualVolumeIDs : ").append(Arrays.toString(virtualVolumeIDs)).append(",");
        sb.append(" virtualVolumeHostID : ").append(virtualVolumeHostID).append(",");
        sb.append(" bindContext : ").append(bindContext).append(",");
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private java.util.UUID[] virtualVolumeIDs;
        private java.util.UUID virtualVolumeHostID;
        private String bindContext;

        private Builder() { }

        public BindVirtualVolumesRequest build() {
            return new BindVirtualVolumesRequest (
                         this.virtualVolumeIDs,
                         this.virtualVolumeHostID,
                         this.bindContext);
        }

        private BindVirtualVolumesRequest.Builder buildFrom(final BindVirtualVolumesRequest req) {
            this.virtualVolumeIDs = req.virtualVolumeIDs;
            this.virtualVolumeHostID = req.virtualVolumeHostID;
            this.bindContext = req.bindContext;

            return this;
        }

        public BindVirtualVolumesRequest.Builder virtualVolumeIDs(final java.util.UUID[] virtualVolumeIDs) {
            this.virtualVolumeIDs = virtualVolumeIDs;
            return this;
        }

        public BindVirtualVolumesRequest.Builder virtualVolumeHostID(final java.util.UUID virtualVolumeHostID) {
            this.virtualVolumeHostID = virtualVolumeHostID;
            return this;
        }

        public BindVirtualVolumesRequest.Builder bindContext(final String bindContext) {
            this.bindContext = bindContext;
            return this;
        }

    }
}
