/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * CloneVirtualVolumeRequest  
 * CloneVirtualVolume is used to execute a VMware Virtual Volume clone.
 **/

public class CloneVirtualVolumeRequest implements Serializable {

    public static final long serialVersionUID = -8173146148363730690L;
    @SerializedName("virtualVolumeID") private java.util.UUID virtualVolumeID;
    @SerializedName("name") private Optional<String> name;
    @SerializedName("qos") private Optional<QoS> qos;
    @SerializedName("metadata") private Optional<Attributes> metadata;
    @SerializedName("newContainerID") private Optional<java.util.UUID> newContainerID;
    @SerializedName("callingVirtualVolumeHostID") private Optional<java.util.UUID> callingVirtualVolumeHostID;

    // empty constructor
    @Since("7.0")
    public CloneVirtualVolumeRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public CloneVirtualVolumeRequest(
        java.util.UUID virtualVolumeID,
        Optional<String> name,
        Optional<QoS> qos,
        Optional<Attributes> metadata,
        Optional<java.util.UUID> newContainerID,
        Optional<java.util.UUID> callingVirtualVolumeHostID
    )
    {
        this.virtualVolumeID = virtualVolumeID;
        this.name = (name == null) ? Optional.<String>empty() : name;
        this.qos = (qos == null) ? Optional.<QoS>empty() : qos;
        this.metadata = (metadata == null) ? Optional.<Attributes>empty() : metadata;
        this.newContainerID = (newContainerID == null) ? Optional.<java.util.UUID>empty() : newContainerID;
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    /** 
     * The ID of the Virtual Volume to clone.
     **/
    public java.util.UUID getVirtualVolumeID() { return this.virtualVolumeID; }
    public void setVirtualVolumeID(java.util.UUID virtualVolumeID) { 
        this.virtualVolumeID = virtualVolumeID;
    }
    /** 
     * The name for the newly-created volume.
     **/
    public Optional<String> getName() { return this.name; }
    public void setName(Optional<String> name) { 
        this.name = (name == null) ? Optional.<String>empty() : name;
    }
    /** 
     * New quality of service settings for this volume.
     **/
    public Optional<QoS> getQos() { return this.qos; }
    public void setQos(Optional<QoS> qos) { 
        this.qos = (qos == null) ? Optional.<QoS>empty() : qos;
    }
    /** 
     * 
     **/
    public Optional<Attributes> getMetadata() { return this.metadata; }
    public void setMetadata(Optional<Attributes> metadata) { 
        this.metadata = (metadata == null) ? Optional.<Attributes>empty() : metadata;
    }
    /** 
     * 
     **/
    public Optional<java.util.UUID> getNewContainerID() { return this.newContainerID; }
    public void setNewContainerID(Optional<java.util.UUID> newContainerID) { 
        this.newContainerID = (newContainerID == null) ? Optional.<java.util.UUID>empty() : newContainerID;
    }
    /** 
     * 
     **/
    public Optional<java.util.UUID> getCallingVirtualVolumeHostID() { return this.callingVirtualVolumeHostID; }
    public void setCallingVirtualVolumeHostID(Optional<java.util.UUID> callingVirtualVolumeHostID) { 
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        CloneVirtualVolumeRequest that = (CloneVirtualVolumeRequest) o;

        return 
            Objects.equals(virtualVolumeID, that.virtualVolumeID) && 
            Objects.equals(name, that.name) && 
            Objects.equals(qos, that.qos) && 
            Objects.equals(metadata, that.metadata) && 
            Objects.equals(newContainerID, that.newContainerID) && 
            Objects.equals(callingVirtualVolumeHostID, that.callingVirtualVolumeHostID);
    }

    @Override
    public int hashCode() {
        return Objects.hash( virtualVolumeID,name,qos,metadata,newContainerID,callingVirtualVolumeHostID );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("virtualVolumeID", virtualVolumeID);
        map.put("name", name);
        map.put("qos", qos);
        map.put("metadata", metadata);
        map.put("newContainerID", newContainerID);
        map.put("callingVirtualVolumeHostID", callingVirtualVolumeHostID);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" virtualVolumeID : ").append(virtualVolumeID).append(",");
        if(null != name && name.isPresent()){
            sb.append(" name : ").append(name).append(",");
        }
        if(null != qos && qos.isPresent()){
            sb.append(" qos : ").append(qos).append(",");
        }
        if(null != metadata && metadata.isPresent()){
            sb.append(" metadata : ").append(metadata).append(",");
        }
        if(null != newContainerID && newContainerID.isPresent()){
            sb.append(" newContainerID : ").append(newContainerID).append(",");
        }
        if(null != callingVirtualVolumeHostID && callingVirtualVolumeHostID.isPresent()){
            sb.append(" callingVirtualVolumeHostID : ").append(callingVirtualVolumeHostID).append(",");
        }
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private java.util.UUID virtualVolumeID;
        private Optional<String> name;
        private Optional<QoS> qos;
        private Optional<Attributes> metadata;
        private Optional<java.util.UUID> newContainerID;
        private Optional<java.util.UUID> callingVirtualVolumeHostID;

        private Builder() { }

        public CloneVirtualVolumeRequest build() {
            return new CloneVirtualVolumeRequest (
                         this.virtualVolumeID,
                         this.name,
                         this.qos,
                         this.metadata,
                         this.newContainerID,
                         this.callingVirtualVolumeHostID);
        }

        private CloneVirtualVolumeRequest.Builder buildFrom(final CloneVirtualVolumeRequest req) {
            this.virtualVolumeID = req.virtualVolumeID;
            this.name = req.name;
            this.qos = req.qos;
            this.metadata = req.metadata;
            this.newContainerID = req.newContainerID;
            this.callingVirtualVolumeHostID = req.callingVirtualVolumeHostID;

            return this;
        }

        public CloneVirtualVolumeRequest.Builder virtualVolumeID(final java.util.UUID virtualVolumeID) {
            this.virtualVolumeID = virtualVolumeID;
            return this;
        }

        public CloneVirtualVolumeRequest.Builder optionalName(final String name) {
            this.name = (name == null) ? Optional.<String>empty() : Optional.of(name);
            return this;
        }

        public CloneVirtualVolumeRequest.Builder optionalQos(final QoS qos) {
            this.qos = (qos == null) ? Optional.<QoS>empty() : Optional.of(qos);
            return this;
        }

        public CloneVirtualVolumeRequest.Builder optionalMetadata(final Attributes metadata) {
            this.metadata = (metadata == null) ? Optional.<Attributes>empty() : Optional.of(metadata);
            return this;
        }

        public CloneVirtualVolumeRequest.Builder optionalNewContainerID(final java.util.UUID newContainerID) {
            this.newContainerID = (newContainerID == null) ? Optional.<java.util.UUID>empty() : Optional.of(newContainerID);
            return this;
        }

        public CloneVirtualVolumeRequest.Builder optionalCallingVirtualVolumeHostID(final java.util.UUID callingVirtualVolumeHostID) {
            this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : Optional.of(callingVirtualVolumeHostID);
            return this;
        }

    }
}
