/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * CopyDiffsToVirtualVolumeRequest  
 * CopyDiffsToVirtualVolume is a three-way merge function.
 **/

public class CopyDiffsToVirtualVolumeRequest implements Serializable {

    public static final long serialVersionUID = -1691419412753280042L;
    @SerializedName("virtualVolumeID") private java.util.UUID virtualVolumeID;
    @SerializedName("baseVirtualVolumeID") private java.util.UUID baseVirtualVolumeID;
    @SerializedName("dstVirtualVolumeID") private java.util.UUID dstVirtualVolumeID;
    @SerializedName("callingVirtualVolumeHostID") private Optional<java.util.UUID> callingVirtualVolumeHostID;

    // empty constructor
    @Since("7.0")
    public CopyDiffsToVirtualVolumeRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public CopyDiffsToVirtualVolumeRequest(
        java.util.UUID virtualVolumeID,
        java.util.UUID baseVirtualVolumeID,
        java.util.UUID dstVirtualVolumeID,
        Optional<java.util.UUID> callingVirtualVolumeHostID
    )
    {
        this.virtualVolumeID = virtualVolumeID;
        this.baseVirtualVolumeID = baseVirtualVolumeID;
        this.dstVirtualVolumeID = dstVirtualVolumeID;
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    /** 
     * The ID of the snapshot Virtual Volume.
     **/
    public java.util.UUID getVirtualVolumeID() { return this.virtualVolumeID; }
    public void setVirtualVolumeID(java.util.UUID virtualVolumeID) { 
        this.virtualVolumeID = virtualVolumeID;
    }
    /** 
     * The ID of the base Virtual Volume.
     **/
    public java.util.UUID getBaseVirtualVolumeID() { return this.baseVirtualVolumeID; }
    public void setBaseVirtualVolumeID(java.util.UUID baseVirtualVolumeID) { 
        this.baseVirtualVolumeID = baseVirtualVolumeID;
    }
    /** 
     * The ID of the Virtual Volume to be overwritten.
     **/
    public java.util.UUID getDstVirtualVolumeID() { return this.dstVirtualVolumeID; }
    public void setDstVirtualVolumeID(java.util.UUID dstVirtualVolumeID) { 
        this.dstVirtualVolumeID = dstVirtualVolumeID;
    }
    /** 
     * 
     **/
    public Optional<java.util.UUID> getCallingVirtualVolumeHostID() { return this.callingVirtualVolumeHostID; }
    public void setCallingVirtualVolumeHostID(Optional<java.util.UUID> callingVirtualVolumeHostID) { 
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        CopyDiffsToVirtualVolumeRequest that = (CopyDiffsToVirtualVolumeRequest) o;

        return 
            Objects.equals(virtualVolumeID, that.virtualVolumeID) && 
            Objects.equals(baseVirtualVolumeID, that.baseVirtualVolumeID) && 
            Objects.equals(dstVirtualVolumeID, that.dstVirtualVolumeID) && 
            Objects.equals(callingVirtualVolumeHostID, that.callingVirtualVolumeHostID);
    }

    @Override
    public int hashCode() {
        return Objects.hash( virtualVolumeID,baseVirtualVolumeID,dstVirtualVolumeID,callingVirtualVolumeHostID );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("virtualVolumeID", virtualVolumeID);
        map.put("baseVirtualVolumeID", baseVirtualVolumeID);
        map.put("dstVirtualVolumeID", dstVirtualVolumeID);
        map.put("callingVirtualVolumeHostID", callingVirtualVolumeHostID);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" virtualVolumeID : ").append(virtualVolumeID).append(",");
        sb.append(" baseVirtualVolumeID : ").append(baseVirtualVolumeID).append(",");
        sb.append(" dstVirtualVolumeID : ").append(dstVirtualVolumeID).append(",");
        if(null != callingVirtualVolumeHostID && callingVirtualVolumeHostID.isPresent()){
            sb.append(" callingVirtualVolumeHostID : ").append(callingVirtualVolumeHostID).append(",");
        }
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private java.util.UUID virtualVolumeID;
        private java.util.UUID baseVirtualVolumeID;
        private java.util.UUID dstVirtualVolumeID;
        private Optional<java.util.UUID> callingVirtualVolumeHostID;

        private Builder() { }

        public CopyDiffsToVirtualVolumeRequest build() {
            return new CopyDiffsToVirtualVolumeRequest (
                         this.virtualVolumeID,
                         this.baseVirtualVolumeID,
                         this.dstVirtualVolumeID,
                         this.callingVirtualVolumeHostID);
        }

        private CopyDiffsToVirtualVolumeRequest.Builder buildFrom(final CopyDiffsToVirtualVolumeRequest req) {
            this.virtualVolumeID = req.virtualVolumeID;
            this.baseVirtualVolumeID = req.baseVirtualVolumeID;
            this.dstVirtualVolumeID = req.dstVirtualVolumeID;
            this.callingVirtualVolumeHostID = req.callingVirtualVolumeHostID;

            return this;
        }

        public CopyDiffsToVirtualVolumeRequest.Builder virtualVolumeID(final java.util.UUID virtualVolumeID) {
            this.virtualVolumeID = virtualVolumeID;
            return this;
        }

        public CopyDiffsToVirtualVolumeRequest.Builder baseVirtualVolumeID(final java.util.UUID baseVirtualVolumeID) {
            this.baseVirtualVolumeID = baseVirtualVolumeID;
            return this;
        }

        public CopyDiffsToVirtualVolumeRequest.Builder dstVirtualVolumeID(final java.util.UUID dstVirtualVolumeID) {
            this.dstVirtualVolumeID = dstVirtualVolumeID;
            return this;
        }

        public CopyDiffsToVirtualVolumeRequest.Builder optionalCallingVirtualVolumeHostID(final java.util.UUID callingVirtualVolumeHostID) {
            this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : Optional.of(callingVirtualVolumeHostID);
            return this;
        }

    }
}
