/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * CreateVirtualVolumeRequest  
 * CreateVirtualVolume is used to create a new (empty) Virtual Volume on the cluster.
 * When the volume is created successfully it is available for connection via PE.
 **/

public class CreateVirtualVolumeRequest implements Serializable {

    public static final long serialVersionUID = -7235302509098264108L;
    @SerializedName("name") private String name;
    @SerializedName("storageContainerID") private java.util.UUID storageContainerID;
    @SerializedName("virtualVolumeType") private String virtualVolumeType;
    @SerializedName("totalSize") private Long totalSize;
    @SerializedName("qos") private Optional<QoS> qos;
    @SerializedName("metadata") private Optional<Attributes> metadata;
    @SerializedName("callingVirtualVolumeHostID") private Optional<java.util.UUID> callingVirtualVolumeHostID;

    // empty constructor
    @Since("7.0")
    public CreateVirtualVolumeRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public CreateVirtualVolumeRequest(
        String name,
        java.util.UUID storageContainerID,
        String virtualVolumeType,
        Long totalSize,
        Optional<QoS> qos,
        Optional<Attributes> metadata,
        Optional<java.util.UUID> callingVirtualVolumeHostID
    )
    {
        this.name = name;
        this.storageContainerID = storageContainerID;
        this.virtualVolumeType = virtualVolumeType;
        this.totalSize = totalSize;
        this.qos = (qos == null) ? Optional.<QoS>empty() : qos;
        this.metadata = (metadata == null) ? Optional.<Attributes>empty() : metadata;
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    /** 
     * Name of the Virtual Volume.
     * Not required to be unique, but it is recommended.
     * May be 1 to 64 characters in length.
     **/
    public String getName() { return this.name; }
    public void setName(String name) { 
        this.name = name;
    }
    /** 
     * UUID for the Storage Container of this volume.
     **/
    public java.util.UUID getStorageContainerID() { return this.storageContainerID; }
    public void setStorageContainerID(java.util.UUID storageContainerID) { 
        this.storageContainerID = storageContainerID;
    }
    /** 
     * VMW_TYPE value for this volume.
     **/
    public String getVirtualVolumeType() { return this.virtualVolumeType; }
    public void setVirtualVolumeType(String virtualVolumeType) { 
        this.virtualVolumeType = virtualVolumeType;
    }
    /** 
     * Total size of the volume, in bytes. Size is rounded up to the nearest 1MB size.
     **/
    public Long getTotalSize() { return this.totalSize; }
    public void setTotalSize(Long totalSize) { 
        this.totalSize = totalSize;
    }
    /** 
     * Initial quality of service settings for this volume.
     * 
     * Volumes created without specified QoS values are created with the default values for QoS.
     * Default values for a volume can be found by running the GetDefaultQoS method.
     **/
    public Optional<QoS> getQos() { return this.qos; }
    public void setQos(Optional<QoS> qos) { 
        this.qos = (qos == null) ? Optional.<QoS>empty() : qos;
    }
    /** 
     * List of name/value pairs to save in the volume's metadata.
     **/
    public Optional<Attributes> getMetadata() { return this.metadata; }
    public void setMetadata(Optional<Attributes> metadata) { 
        this.metadata = (metadata == null) ? Optional.<Attributes>empty() : metadata;
    }
    /** 
     * 
     **/
    public Optional<java.util.UUID> getCallingVirtualVolumeHostID() { return this.callingVirtualVolumeHostID; }
    public void setCallingVirtualVolumeHostID(Optional<java.util.UUID> callingVirtualVolumeHostID) { 
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        CreateVirtualVolumeRequest that = (CreateVirtualVolumeRequest) o;

        return 
            Objects.equals(name, that.name) && 
            Objects.equals(storageContainerID, that.storageContainerID) && 
            Objects.equals(virtualVolumeType, that.virtualVolumeType) && 
            Objects.equals(totalSize, that.totalSize) && 
            Objects.equals(qos, that.qos) && 
            Objects.equals(metadata, that.metadata) && 
            Objects.equals(callingVirtualVolumeHostID, that.callingVirtualVolumeHostID);
    }

    @Override
    public int hashCode() {
        return Objects.hash( name,storageContainerID,virtualVolumeType,totalSize,qos,metadata,callingVirtualVolumeHostID );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("name", name);
        map.put("storageContainerID", storageContainerID);
        map.put("virtualVolumeType", virtualVolumeType);
        map.put("totalSize", totalSize);
        map.put("qos", qos);
        map.put("metadata", metadata);
        map.put("callingVirtualVolumeHostID", callingVirtualVolumeHostID);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" name : ").append(name).append(",");
        sb.append(" storageContainerID : ").append(storageContainerID).append(",");
        sb.append(" virtualVolumeType : ").append(virtualVolumeType).append(",");
        sb.append(" totalSize : ").append(totalSize).append(",");
        if(null != qos && qos.isPresent()){
            sb.append(" qos : ").append(qos).append(",");
        }
        if(null != metadata && metadata.isPresent()){
            sb.append(" metadata : ").append(metadata).append(",");
        }
        if(null != callingVirtualVolumeHostID && callingVirtualVolumeHostID.isPresent()){
            sb.append(" callingVirtualVolumeHostID : ").append(callingVirtualVolumeHostID).append(",");
        }
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private String name;
        private java.util.UUID storageContainerID;
        private String virtualVolumeType;
        private Long totalSize;
        private Optional<QoS> qos;
        private Optional<Attributes> metadata;
        private Optional<java.util.UUID> callingVirtualVolumeHostID;

        private Builder() { }

        public CreateVirtualVolumeRequest build() {
            return new CreateVirtualVolumeRequest (
                         this.name,
                         this.storageContainerID,
                         this.virtualVolumeType,
                         this.totalSize,
                         this.qos,
                         this.metadata,
                         this.callingVirtualVolumeHostID);
        }

        private CreateVirtualVolumeRequest.Builder buildFrom(final CreateVirtualVolumeRequest req) {
            this.name = req.name;
            this.storageContainerID = req.storageContainerID;
            this.virtualVolumeType = req.virtualVolumeType;
            this.totalSize = req.totalSize;
            this.qos = req.qos;
            this.metadata = req.metadata;
            this.callingVirtualVolumeHostID = req.callingVirtualVolumeHostID;

            return this;
        }

        public CreateVirtualVolumeRequest.Builder name(final String name) {
            this.name = name;
            return this;
        }

        public CreateVirtualVolumeRequest.Builder storageContainerID(final java.util.UUID storageContainerID) {
            this.storageContainerID = storageContainerID;
            return this;
        }

        public CreateVirtualVolumeRequest.Builder virtualVolumeType(final String virtualVolumeType) {
            this.virtualVolumeType = virtualVolumeType;
            return this;
        }

        public CreateVirtualVolumeRequest.Builder totalSize(final Long totalSize) {
            this.totalSize = totalSize;
            return this;
        }

        public CreateVirtualVolumeRequest.Builder optionalQos(final QoS qos) {
            this.qos = (qos == null) ? Optional.<QoS>empty() : Optional.of(qos);
            return this;
        }

        public CreateVirtualVolumeRequest.Builder optionalMetadata(final Attributes metadata) {
            this.metadata = (metadata == null) ? Optional.<Attributes>empty() : Optional.of(metadata);
            return this;
        }

        public CreateVirtualVolumeRequest.Builder optionalCallingVirtualVolumeHostID(final java.util.UUID callingVirtualVolumeHostID) {
            this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : Optional.of(callingVirtualVolumeHostID);
            return this;
        }

    }
}
