/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * DeleteVirtualVolumesRequest  
 * DeleteVirtualVolume marks an active volume for deletion.
 * It is purged (permanently deleted) after the cleanup interval elapses.
 * After making a request to delete a volume, any active iSCSI connections to the volume is immediately terminated and no further connections are allowed while the volume is in this state.
 * It is not returned in target discovery requests.
 * 
 * Any snapshots of a volume that has been marked to delete are not affected.
 * Snapshots are kept until the volume is purged from the system.
 * 
 * If a volume is marked for deletion, and it has a bulk volume read or bulk volume write operation in progress, the bulk volume operation is stopped.
 * 
 * If the volume you delete is paired with a volume, replication between the paired volumes is suspended and no data is transferred to it or from it while in a deleted state.
 * The remote volume the deleted volume was paired with enters into a PausedMisconfigured state and data is no integerer sent to it or from the deleted volume.
 * Until the deleted volume is purged, it can be restored and data transfers resumes.
 * If the deleted volume gets purged from the system, the volume it was paired with enters into a StoppedMisconfigured state and the volume pairing status is removed.
 * The purged volume becomes permanently unavailable.
 **/

public class DeleteVirtualVolumesRequest implements Serializable {

    public static final long serialVersionUID = 4791308200209281633L;
    @SerializedName("virtualVolumes") private java.util.UUID[] virtualVolumes;
    @SerializedName("callingVirtualVolumeHostID") private Optional<java.util.UUID> callingVirtualVolumeHostID;

    // empty constructor
    @Since("7.0")
    public DeleteVirtualVolumesRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public DeleteVirtualVolumesRequest(
        java.util.UUID[] virtualVolumes,
        Optional<java.util.UUID> callingVirtualVolumeHostID
    )
    {
        this.virtualVolumes = virtualVolumes;
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    /** 
     * The UUID of the volume to delete.
     **/
    public java.util.UUID[] getVirtualVolumes() { return this.virtualVolumes; }
    public void setVirtualVolumes(java.util.UUID[] virtualVolumes) { 
        this.virtualVolumes = virtualVolumes;
    }
    /** 
     * 
     **/
    public Optional<java.util.UUID> getCallingVirtualVolumeHostID() { return this.callingVirtualVolumeHostID; }
    public void setCallingVirtualVolumeHostID(Optional<java.util.UUID> callingVirtualVolumeHostID) { 
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        DeleteVirtualVolumesRequest that = (DeleteVirtualVolumesRequest) o;

        return 
            Arrays.equals(virtualVolumes, that.virtualVolumes) && 
            Objects.equals(callingVirtualVolumeHostID, that.callingVirtualVolumeHostID);
    }

    @Override
    public int hashCode() {
        return Objects.hash( (Object[])virtualVolumes,callingVirtualVolumeHostID );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("virtualVolumes", virtualVolumes);
        map.put("callingVirtualVolumeHostID", callingVirtualVolumeHostID);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" virtualVolumes : ").append(Arrays.toString(virtualVolumes)).append(",");
        if(null != callingVirtualVolumeHostID && callingVirtualVolumeHostID.isPresent()){
            sb.append(" callingVirtualVolumeHostID : ").append(callingVirtualVolumeHostID).append(",");
        }
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private java.util.UUID[] virtualVolumes;
        private Optional<java.util.UUID> callingVirtualVolumeHostID;

        private Builder() { }

        public DeleteVirtualVolumesRequest build() {
            return new DeleteVirtualVolumesRequest (
                         this.virtualVolumes,
                         this.callingVirtualVolumeHostID);
        }

        private DeleteVirtualVolumesRequest.Builder buildFrom(final DeleteVirtualVolumesRequest req) {
            this.virtualVolumes = req.virtualVolumes;
            this.callingVirtualVolumeHostID = req.callingVirtualVolumeHostID;

            return this;
        }

        public DeleteVirtualVolumesRequest.Builder virtualVolumes(final java.util.UUID[] virtualVolumes) {
            this.virtualVolumes = virtualVolumes;
            return this;
        }

        public DeleteVirtualVolumesRequest.Builder optionalCallingVirtualVolumeHostID(final java.util.UUID callingVirtualVolumeHostID) {
            this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : Optional.of(callingVirtualVolumeHostID);
            return this;
        }

    }
}
