/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * GetVirtualVolumeAllocatedBitmapRequest  
 * GetVirtualVolumeAllocatedBitmap returns a b64-encoded block of data 
 * representing a bitmap where non-zero bits indicate the allocation of a 
 * segment (LBA range) of the volume.
 **/

public class GetVirtualVolumeAllocatedBitmapRequest implements Serializable {

    public static final long serialVersionUID = -4714233131961631917L;
    @SerializedName("virtualVolumeID") private java.util.UUID virtualVolumeID;
    @SerializedName("segmentStart") private Long segmentStart;
    @SerializedName("segmentLength") private Long segmentLength;
    @SerializedName("chunkSize") private Long chunkSize;
    @SerializedName("callingVirtualVolumeHostID") private Optional<java.util.UUID> callingVirtualVolumeHostID;

    // empty constructor
    @Since("7.0")
    public GetVirtualVolumeAllocatedBitmapRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public GetVirtualVolumeAllocatedBitmapRequest(
        java.util.UUID virtualVolumeID,
        Long segmentStart,
        Long segmentLength,
        Long chunkSize,
        Optional<java.util.UUID> callingVirtualVolumeHostID
    )
    {
        this.virtualVolumeID = virtualVolumeID;
        this.segmentStart = segmentStart;
        this.segmentLength = segmentLength;
        this.chunkSize = chunkSize;
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    /** 
     * The ID of the Virtual Volume.
     **/
    public java.util.UUID getVirtualVolumeID() { return this.virtualVolumeID; }
    public void setVirtualVolumeID(java.util.UUID virtualVolumeID) { 
        this.virtualVolumeID = virtualVolumeID;
    }
    /** 
     * Byte offset.
     **/
    public Long getSegmentStart() { return this.segmentStart; }
    public void setSegmentStart(Long segmentStart) { 
        this.segmentStart = segmentStart;
    }
    /** 
     * Byte length adjusted to end on a chunk boundary.
     **/
    public Long getSegmentLength() { return this.segmentLength; }
    public void setSegmentLength(Long segmentLength) { 
        this.segmentLength = segmentLength;
    }
    /** 
     * Number of bytes represented by one bit in the bitmap.
     **/
    public Long getChunkSize() { return this.chunkSize; }
    public void setChunkSize(Long chunkSize) { 
        this.chunkSize = chunkSize;
    }
    /** 
     * 
     **/
    public Optional<java.util.UUID> getCallingVirtualVolumeHostID() { return this.callingVirtualVolumeHostID; }
    public void setCallingVirtualVolumeHostID(Optional<java.util.UUID> callingVirtualVolumeHostID) { 
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        GetVirtualVolumeAllocatedBitmapRequest that = (GetVirtualVolumeAllocatedBitmapRequest) o;

        return 
            Objects.equals(virtualVolumeID, that.virtualVolumeID) && 
            Objects.equals(segmentStart, that.segmentStart) && 
            Objects.equals(segmentLength, that.segmentLength) && 
            Objects.equals(chunkSize, that.chunkSize) && 
            Objects.equals(callingVirtualVolumeHostID, that.callingVirtualVolumeHostID);
    }

    @Override
    public int hashCode() {
        return Objects.hash( virtualVolumeID,segmentStart,segmentLength,chunkSize,callingVirtualVolumeHostID );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("virtualVolumeID", virtualVolumeID);
        map.put("segmentStart", segmentStart);
        map.put("segmentLength", segmentLength);
        map.put("chunkSize", chunkSize);
        map.put("callingVirtualVolumeHostID", callingVirtualVolumeHostID);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" virtualVolumeID : ").append(virtualVolumeID).append(",");
        sb.append(" segmentStart : ").append(segmentStart).append(",");
        sb.append(" segmentLength : ").append(segmentLength).append(",");
        sb.append(" chunkSize : ").append(chunkSize).append(",");
        if(null != callingVirtualVolumeHostID && callingVirtualVolumeHostID.isPresent()){
            sb.append(" callingVirtualVolumeHostID : ").append(callingVirtualVolumeHostID).append(",");
        }
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private java.util.UUID virtualVolumeID;
        private Long segmentStart;
        private Long segmentLength;
        private Long chunkSize;
        private Optional<java.util.UUID> callingVirtualVolumeHostID;

        private Builder() { }

        public GetVirtualVolumeAllocatedBitmapRequest build() {
            return new GetVirtualVolumeAllocatedBitmapRequest (
                         this.virtualVolumeID,
                         this.segmentStart,
                         this.segmentLength,
                         this.chunkSize,
                         this.callingVirtualVolumeHostID);
        }

        private GetVirtualVolumeAllocatedBitmapRequest.Builder buildFrom(final GetVirtualVolumeAllocatedBitmapRequest req) {
            this.virtualVolumeID = req.virtualVolumeID;
            this.segmentStart = req.segmentStart;
            this.segmentLength = req.segmentLength;
            this.chunkSize = req.chunkSize;
            this.callingVirtualVolumeHostID = req.callingVirtualVolumeHostID;

            return this;
        }

        public GetVirtualVolumeAllocatedBitmapRequest.Builder virtualVolumeID(final java.util.UUID virtualVolumeID) {
            this.virtualVolumeID = virtualVolumeID;
            return this;
        }

        public GetVirtualVolumeAllocatedBitmapRequest.Builder segmentStart(final Long segmentStart) {
            this.segmentStart = segmentStart;
            return this;
        }

        public GetVirtualVolumeAllocatedBitmapRequest.Builder segmentLength(final Long segmentLength) {
            this.segmentLength = segmentLength;
            return this;
        }

        public GetVirtualVolumeAllocatedBitmapRequest.Builder chunkSize(final Long chunkSize) {
            this.chunkSize = chunkSize;
            return this;
        }

        public GetVirtualVolumeAllocatedBitmapRequest.Builder optionalCallingVirtualVolumeHostID(final java.util.UUID callingVirtualVolumeHostID) {
            this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : Optional.of(callingVirtualVolumeHostID);
            return this;
        }

    }
}
