/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.core.annotation.*;
import com.solidfire.core.javautil.Optional;


/**
 * The API for controlling a SolidFire cluster.
 **/

public interface InternalSolidFireElementIF {

    /** 
     * BindVirtualVolume binds a VVol with a Host.
     **/
    @Since("7.0")
    @ConnectionType("Cluster")
    public VirtualVolumeBindingListResult bindVirtualVolumes(final BindVirtualVolumesRequest request);

    /** 
     * BindVirtualVolume binds a VVol with a Host.
     **/
    @Since("7.0")
    @ConnectionType("Cluster")
    public VirtualVolumeBindingListResult bindVirtualVolumes(
        
        java.util.UUID[] virtualVolumeIDs
, 
        java.util.UUID virtualVolumeHostID
, 
        String bindContext
        );
    /** 
     * CancelVirtualVolumeTask attempts to cancel the VVol Async Task.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult cancelVirtualVolumeTask(final CancelVirtualVolumeTaskRequest request);

    /** 
     * CancelVirtualVolumeTask attempts to cancel the VVol Async Task.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult cancelVirtualVolumeTask(
        
        java.util.UUID virtualVolumeTaskID
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * CloneVirtualVolume is used to execute a VMware Virtual Volume clone.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeAsyncResult cloneVirtualVolume(final CloneVirtualVolumeRequest request);

    /** 
     * CloneVirtualVolume is used to execute a VMware Virtual Volume clone.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeAsyncResult cloneVirtualVolume(
        
        java.util.UUID virtualVolumeID
, 
        Optional<String> name
, 
        Optional<QoS> qos
, 
        Optional<Attributes> metadata
, 
        Optional<java.util.UUID> newContainerID
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * CopyDiffsToVirtualVolume is a three-way merge function.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeAsyncResult copyDiffsToVirtualVolume(final CopyDiffsToVirtualVolumeRequest request);

    /** 
     * CopyDiffsToVirtualVolume is a three-way merge function.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeAsyncResult copyDiffsToVirtualVolume(
        
        java.util.UUID virtualVolumeID
, 
        java.util.UUID baseVirtualVolumeID
, 
        java.util.UUID dstVirtualVolumeID
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * CreateVirtualVolume is used to create a new (empty) Virtual Volume on the cluster.
     * When the volume is created successfully it is available for connection via PE.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeSyncResult createVirtualVolume(final CreateVirtualVolumeRequest request);

    /** 
     * CreateVirtualVolume is used to create a new (empty) Virtual Volume on the cluster.
     * When the volume is created successfully it is available for connection via PE.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeSyncResult createVirtualVolume(
        
        String name
, 
        java.util.UUID storageContainerID
, 
        String virtualVolumeType
, 
        Long totalSize
, 
        Optional<QoS> qos
, 
        Optional<Attributes> metadata
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * CreateVirtualVolumeHost creates a new ESX host.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult createVirtualVolumeHost(final CreateVirtualVolumeHostRequest request);

    /** 
     * CreateVirtualVolumeHost creates a new ESX host.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult createVirtualVolumeHost(
        
        java.util.UUID virtualVolumeHostID
, 
        java.util.UUID clusterID
, 
        Optional<String[]> initiatorNames
, 
        Optional<java.util.UUID[]> visibleProtocolEndpointIDs
, 
        Optional<String> hostAddress
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * DeleteVirtualVolume marks an active volume for deletion.
     * It is purged (permanently deleted) after the cleanup interval elapses.
     * After making a request to delete a volume, any active iSCSI connections to the volume is immediately terminated and no further connections are allowed while the volume is in this state.
     * It is not returned in target discovery requests.
     * 
     * Any snapshots of a volume that has been marked to delete are not affected.
     * Snapshots are kept until the volume is purged from the system.
     * 
     * If a volume is marked for deletion, and it has a bulk volume read or bulk volume write operation in progress, the bulk volume operation is stopped.
     * 
     * If the volume you delete is paired with a volume, replication between the paired volumes is suspended and no data is transferred to it or from it while in a deleted state.
     * The remote volume the deleted volume was paired with enters into a PausedMisconfigured state and data is no integerer sent to it or from the deleted volume.
     * Until the deleted volume is purged, it can be restored and data transfers resumes.
     * If the deleted volume gets purged from the system, the volume it was paired with enters into a StoppedMisconfigured state and the volume pairing status is removed.
     * The purged volume becomes permanently unavailable.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult deleteVirtualVolumes(final DeleteVirtualVolumesRequest request);

    /** 
     * DeleteVirtualVolume marks an active volume for deletion.
     * It is purged (permanently deleted) after the cleanup interval elapses.
     * After making a request to delete a volume, any active iSCSI connections to the volume is immediately terminated and no further connections are allowed while the volume is in this state.
     * It is not returned in target discovery requests.
     * 
     * Any snapshots of a volume that has been marked to delete are not affected.
     * Snapshots are kept until the volume is purged from the system.
     * 
     * If a volume is marked for deletion, and it has a bulk volume read or bulk volume write operation in progress, the bulk volume operation is stopped.
     * 
     * If the volume you delete is paired with a volume, replication between the paired volumes is suspended and no data is transferred to it or from it while in a deleted state.
     * The remote volume the deleted volume was paired with enters into a PausedMisconfigured state and data is no integerer sent to it or from the deleted volume.
     * Until the deleted volume is purged, it can be restored and data transfers resumes.
     * If the deleted volume gets purged from the system, the volume it was paired with enters into a StoppedMisconfigured state and the volume pairing status is removed.
     * The purged volume becomes permanently unavailable.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult deleteVirtualVolumes(
        
        java.util.UUID[] virtualVolumes
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * FastCloneVirtualVolume is used to execute a VMware Virtual Volume fast clone.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeAsyncResult fastCloneVirtualVolume(final FastCloneVirtualVolumeRequest request);

    /** 
     * FastCloneVirtualVolume is used to execute a VMware Virtual Volume fast clone.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeAsyncResult fastCloneVirtualVolume(
        
        java.util.UUID virtualVolumeID
, 
        Optional<String> name
, 
        Optional<QoS> qos
, 
        Optional<Attributes> metadata
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * Gets the Vasa Provider info
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VasaProviderInfoResult getVasaProviderInfo();
    /** 
     * GetVirtualVolumeAllocatedBitmap returns a b64-encoded block of data 
     * representing a bitmap where non-zero bits indicate the allocation of a 
     * segment (LBA range) of the volume.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeBitmapResult getVirtualVolumeAllocatedBitmap(final GetVirtualVolumeAllocatedBitmapRequest request);

    /** 
     * GetVirtualVolumeAllocatedBitmap returns a b64-encoded block of data 
     * representing a bitmap where non-zero bits indicate the allocation of a 
     * segment (LBA range) of the volume.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeBitmapResult getVirtualVolumeAllocatedBitmap(
        
        java.util.UUID virtualVolumeID
, 
        Long segmentStart
, 
        Long segmentLength
, 
        Long chunkSize
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * GetVirtualVolumeTaskUpdate checks the status of a VVol Async Task.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeTaskResult getVirtualVolumeTaskUpdate(final GetVirtualVolumeTaskUpdateRequest request);

    /** 
     * GetVirtualVolumeTaskUpdate checks the status of a VVol Async Task.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeTaskResult getVirtualVolumeTaskUpdate(
        
        java.util.UUID virtualVolumeTaskID
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * GetVirtualVolumeAllocatedBitmap returns a b64-encoded block of data 
     * representing a bitmap where non-zero bits indicate that data is not the same 
     * between two volumes for a common segment (LBA range) of the volumes.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeBitmapResult getVirtualVolumeUnsharedBitmap(final GetVirtualVolumeUnsharedBitmapRequest request);

    /** 
     * GetVirtualVolumeAllocatedBitmap returns a b64-encoded block of data 
     * representing a bitmap where non-zero bits indicate that data is not the same 
     * between two volumes for a common segment (LBA range) of the volumes.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeBitmapResult getVirtualVolumeUnsharedBitmap(
        
        java.util.UUID virtualVolumeID
, 
        java.util.UUID baseVirtualVolumeID
, 
        Long segmentStart
, 
        Long segmentLength
, 
        Long chunkSize
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * GetVirtualVolumeAllocatedBitmap scans a VVol segment and returns the number of 
     * chunks not shared between two volumes. This call will return results in less 
     * than 30 seconds. If the specified VVol and the base VVil are not related, an 
     * error is thrown. If the offset/length combination is invalid or out fo range 
     * an error is thrown.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeUnsharedChunkResult getVirtualVolumeUnsharedChunks(final GetVirtualVolumeUnsharedChunksRequest request);

    /** 
     * GetVirtualVolumeAllocatedBitmap scans a VVol segment and returns the number of 
     * chunks not shared between two volumes. This call will return results in less 
     * than 30 seconds. If the specified VVol and the base VVil are not related, an 
     * error is thrown. If the offset/length combination is invalid or out fo range 
     * an error is thrown.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeUnsharedChunkResult getVirtualVolumeUnsharedChunks(
        
        java.util.UUID virtualVolumeID
, 
        java.util.UUID baseVirtualVolumeID
, 
        Long segmentStart
, 
        Long segmentLength
, 
        Long chunkSize
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * Update the Vasa Provider info
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult modifyVasaProviderInfo(final ModifyVasaProviderInfoRequest request);

    /** 
     * Update the Vasa Provider info
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult modifyVasaProviderInfo(
        
        Optional<String> keystore
, 
        Optional<java.util.UUID> vasaProviderID
, 
        Optional<Attributes> options
        );
    /** 
     * ModifyVirtualVolume is used to modify settings on an existing virtual volume.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult modifyVirtualVolume(final ModifyVirtualVolumeRequest request);

    /** 
     * ModifyVirtualVolume is used to modify settings on an existing virtual volume.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult modifyVirtualVolume(
        
        java.util.UUID virtualVolumeID
, 
        Optional<QoS> qos
, 
        Optional<Long> totalSize
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * ModifyVirtualVolumeHost changes an existing ESX host.
     **/
    @Since("7.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult modifyVirtualVolumeHost(final ModifyVirtualVolumeHostRequest request);

    /** 
     * ModifyVirtualVolumeHost changes an existing ESX host.
     **/
    @Since("7.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult modifyVirtualVolumeHost(
        
        java.util.UUID virtualVolumeHostID
, 
        Optional<java.util.UUID> clusterID
, 
        Optional<java.util.UUID[]> visibleProtocolEndpointIDs
, 
        Optional<String[]> initiatorNames
, 
        Optional<String> hostAddress
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * ModifyVirtualVolumeMetadata is used to selectively modify the VVol metadata.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult modifyVirtualVolumeMetadata(final ModifyVirtualVolumeMetadataRequest request);

    /** 
     * ModifyVirtualVolumeMetadata is used to selectively modify the VVol metadata.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeNullResult modifyVirtualVolumeMetadata(
        
        java.util.UUID virtualVolumeID
, 
        Attributes metadata
, 
        String[] removeKeys
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * PrepareVirtualSnapshot is used to set up VMware Virtual Volume snapshot.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public PrepareVirtualSnapshotResult prepareVirtualSnapshot(final PrepareVirtualSnapshotRequest request);

    /** 
     * PrepareVirtualSnapshot is used to set up VMware Virtual Volume snapshot.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public PrepareVirtualSnapshotResult prepareVirtualSnapshot(
        
        java.util.UUID virtualVolumeID
, 
        Optional<String> name
, 
        Optional<Boolean> writableSnapshot
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * QueryVirtualVolumeMetadata returns a list of VVols matching a metadata query.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public QueryVirtualVolumeMetadataResult queryVirtualVolumeMetadata(final QueryVirtualVolumeMetadataRequest request);

    /** 
     * QueryVirtualVolumeMetadata returns a list of VVols matching a metadata query.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public QueryVirtualVolumeMetadataResult queryVirtualVolumeMetadata(
        
        Optional<Attributes> queryConstraints
, 
        Optional<String[]> wildcardConstraints
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * RollbackVirtualVolume is used to restore a VMware Virtual Volume snapshot.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeAsyncResult rollbackVirtualVolume(final RollbackVirtualVolumeRequest request);

    /** 
     * RollbackVirtualVolume is used to restore a VMware Virtual Volume snapshot.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public VirtualVolumeAsyncResult rollbackVirtualVolume(
        
        java.util.UUID srcVirtualVolumeID
, 
        java.util.UUID dstVirtualVolumeID
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * SnapshotVirtualVolume is used to take a VMware Virtual Volume snapshot.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public SnapshotVirtualVolumeResult snapshotVirtualVolume(final SnapshotVirtualVolumeRequest request);

    /** 
     * SnapshotVirtualVolume is used to take a VMware Virtual Volume snapshot.
     **/
    @Since("9.0")
    @ConnectionType("Cluster")
    public SnapshotVirtualVolumeResult snapshotVirtualVolume(
        
        java.util.UUID virtualVolumeID
, 
        Long timeout
, 
        Optional<Attributes> metadata
, 
        Optional<java.util.UUID> callingVirtualVolumeHostID
        );
    /** 
     * UnbindAllVirtualVolumesFromHost removes all VVol <-> Host binding.
     **/
    @Since("7.0")
    @ConnectionType("Cluster")
    public UnbindAllVirtualVolumesFromHostResult unbindAllVirtualVolumesFromHost(final UnbindAllVirtualVolumesFromHostRequest request);

    /** 
     * UnbindAllVirtualVolumesFromHost removes all VVol <-> Host binding.
     **/
    @Since("7.0")
    @ConnectionType("Cluster")
    public UnbindAllVirtualVolumesFromHostResult unbindAllVirtualVolumesFromHost(
        
        java.util.UUID virtualVolumeHostID
        );
    /** 
     * UnbindGetVirtualVolume removes the VVol <-> Host binding.
     **/
    @Since("7.0")
    @ConnectionType("Cluster")
    public VirtualVolumeUnbindResult unbindVirtualVolumes(final UnbindVirtualVolumesRequest request);

    /** 
     * UnbindGetVirtualVolume removes the VVol <-> Host binding.
     **/
    @Since("7.0")
    @ConnectionType("Cluster")
    public VirtualVolumeUnbindResult unbindVirtualVolumes(
        
        String unbindContext
, 
        java.util.UUID virtualVolumeHostID
, 
        UnbindArguments[] unbindArgs
        );
}