/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * ModifyVasaProviderInfoRequest  
 * Update the Vasa Provider info
 **/

public class ModifyVasaProviderInfoRequest implements Serializable {

    public static final long serialVersionUID = 4762648260036920364L;
    @SerializedName("keystore") private Optional<String> keystore;
    @SerializedName("vasaProviderID") private Optional<java.util.UUID> vasaProviderID;
    @SerializedName("options") private Optional<Attributes> options;

    // empty constructor
    @Since("7.0")
    public ModifyVasaProviderInfoRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public ModifyVasaProviderInfoRequest(
        Optional<String> keystore,
        Optional<java.util.UUID> vasaProviderID,
        Optional<Attributes> options
    )
    {
        this.keystore = (keystore == null) ? Optional.<String>empty() : keystore;
        this.vasaProviderID = (vasaProviderID == null) ? Optional.<java.util.UUID>empty() : vasaProviderID;
        this.options = (options == null) ? Optional.<Attributes>empty() : options;
    }

    /** 
     * Signed SSL certificate for the Vasa Provider
     **/
    public Optional<String> getKeystore() { return this.keystore; }
    public void setKeystore(Optional<String> keystore) { 
        this.keystore = (keystore == null) ? Optional.<String>empty() : keystore;
    }
    /** 
     * UUID identifying the vasa provider
     **/
    public Optional<java.util.UUID> getVasaProviderID() { return this.vasaProviderID; }
    public void setVasaProviderID(Optional<java.util.UUID> vasaProviderID) { 
        this.vasaProviderID = (vasaProviderID == null) ? Optional.<java.util.UUID>empty() : vasaProviderID;
    }
    /** 
     * 
     **/
    public Optional<Attributes> getOptions() { return this.options; }
    public void setOptions(Optional<Attributes> options) { 
        this.options = (options == null) ? Optional.<Attributes>empty() : options;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        ModifyVasaProviderInfoRequest that = (ModifyVasaProviderInfoRequest) o;

        return 
            Objects.equals(keystore, that.keystore) && 
            Objects.equals(vasaProviderID, that.vasaProviderID) && 
            Objects.equals(options, that.options);
    }

    @Override
    public int hashCode() {
        return Objects.hash( keystore,vasaProviderID,options );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("keystore", keystore);
        map.put("vasaProviderID", vasaProviderID);
        map.put("options", options);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        if(null != keystore && keystore.isPresent()){
            sb.append(" keystore : ").append(keystore).append(",");
        }
        if(null != vasaProviderID && vasaProviderID.isPresent()){
            sb.append(" vasaProviderID : ").append(vasaProviderID).append(",");
        }
        if(null != options && options.isPresent()){
            sb.append(" options : ").append(options).append(",");
        }
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private Optional<String> keystore;
        private Optional<java.util.UUID> vasaProviderID;
        private Optional<Attributes> options;

        private Builder() { }

        public ModifyVasaProviderInfoRequest build() {
            return new ModifyVasaProviderInfoRequest (
                         this.keystore,
                         this.vasaProviderID,
                         this.options);
        }

        private ModifyVasaProviderInfoRequest.Builder buildFrom(final ModifyVasaProviderInfoRequest req) {
            this.keystore = req.keystore;
            this.vasaProviderID = req.vasaProviderID;
            this.options = req.options;

            return this;
        }

        public ModifyVasaProviderInfoRequest.Builder optionalKeystore(final String keystore) {
            this.keystore = (keystore == null) ? Optional.<String>empty() : Optional.of(keystore);
            return this;
        }

        public ModifyVasaProviderInfoRequest.Builder optionalVasaProviderID(final java.util.UUID vasaProviderID) {
            this.vasaProviderID = (vasaProviderID == null) ? Optional.<java.util.UUID>empty() : Optional.of(vasaProviderID);
            return this;
        }

        public ModifyVasaProviderInfoRequest.Builder optionalOptions(final Attributes options) {
            this.options = (options == null) ? Optional.<Attributes>empty() : Optional.of(options);
            return this;
        }

    }
}
