/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * ModifyVirtualVolumeHostRequest  
 * ModifyVirtualVolumeHost changes an existing ESX host.
 **/

public class ModifyVirtualVolumeHostRequest implements Serializable {

    public static final long serialVersionUID = 8882264729637984302L;
    @SerializedName("virtualVolumeHostID") private java.util.UUID virtualVolumeHostID;
    @SerializedName("clusterID") private Optional<java.util.UUID> clusterID;
    @SerializedName("visibleProtocolEndpointIDs") private Optional<java.util.UUID[]> visibleProtocolEndpointIDs;
    @SerializedName("initiatorNames") private Optional<String[]> initiatorNames;
    @SerializedName("hostAddress") private Optional<String> hostAddress;
    @SerializedName("callingVirtualVolumeHostID") private Optional<java.util.UUID> callingVirtualVolumeHostID;

    // empty constructor
    @Since("7.0")
    public ModifyVirtualVolumeHostRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public ModifyVirtualVolumeHostRequest(
        java.util.UUID virtualVolumeHostID,
        Optional<java.util.UUID> clusterID,
        Optional<java.util.UUID[]> visibleProtocolEndpointIDs,
        Optional<String[]> initiatorNames,
        Optional<String> hostAddress,
        Optional<java.util.UUID> callingVirtualVolumeHostID
    )
    {
        this.virtualVolumeHostID = virtualVolumeHostID;
        this.clusterID = (clusterID == null) ? Optional.<java.util.UUID>empty() : clusterID;
        this.visibleProtocolEndpointIDs = (visibleProtocolEndpointIDs == null) ? Optional.<java.util.UUID[]>empty() : visibleProtocolEndpointIDs;
        this.initiatorNames = (initiatorNames == null) ? Optional.<String[]>empty() : initiatorNames;
        this.hostAddress = (hostAddress == null) ? Optional.<String>empty() : hostAddress;
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    /** 
     * The GUID of the ESX host.
     **/
    public java.util.UUID getVirtualVolumeHostID() { return this.virtualVolumeHostID; }
    public void setVirtualVolumeHostID(java.util.UUID virtualVolumeHostID) { 
        this.virtualVolumeHostID = virtualVolumeHostID;
    }
    /** 
     * The GUID of the ESX Cluster.
     **/
    public Optional<java.util.UUID> getClusterID() { return this.clusterID; }
    public void setClusterID(Optional<java.util.UUID> clusterID) { 
        this.clusterID = (clusterID == null) ? Optional.<java.util.UUID>empty() : clusterID;
    }
    /** 
     * A list of PEs the host is aware of.
     **/
    public Optional<java.util.UUID[]> getVisibleProtocolEndpointIDs() { return this.visibleProtocolEndpointIDs; }
    public void setVisibleProtocolEndpointIDs(Optional<java.util.UUID[]> visibleProtocolEndpointIDs) { 
        this.visibleProtocolEndpointIDs = (visibleProtocolEndpointIDs == null) ? Optional.<java.util.UUID[]>empty() : visibleProtocolEndpointIDs;
    }
    /** 
     * List of iSCSI initiator IQNs for the host.
     **/
    public Optional<String[]> getInitiatorNames() { return this.initiatorNames; }
    public void setInitiatorNames(Optional<String[]> initiatorNames) { 
        this.initiatorNames = (initiatorNames == null) ? Optional.<String[]>empty() : initiatorNames;
    }
    /** 
     * IP or DNS name for the host.
     **/
    public Optional<String> getHostAddress() { return this.hostAddress; }
    public void setHostAddress(Optional<String> hostAddress) { 
        this.hostAddress = (hostAddress == null) ? Optional.<String>empty() : hostAddress;
    }
    /** 
     * ModifyVirtualVolumeHost changes an existing ESX host.
     **/
    public Optional<java.util.UUID> getCallingVirtualVolumeHostID() { return this.callingVirtualVolumeHostID; }
    public void setCallingVirtualVolumeHostID(Optional<java.util.UUID> callingVirtualVolumeHostID) { 
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        ModifyVirtualVolumeHostRequest that = (ModifyVirtualVolumeHostRequest) o;

        return 
            Objects.equals(virtualVolumeHostID, that.virtualVolumeHostID) && 
            Objects.equals(clusterID, that.clusterID) && 
            Objects.equals(visibleProtocolEndpointIDs, that.visibleProtocolEndpointIDs) && 
            Objects.equals(initiatorNames, that.initiatorNames) && 
            Objects.equals(hostAddress, that.hostAddress) && 
            Objects.equals(callingVirtualVolumeHostID, that.callingVirtualVolumeHostID);
    }

    @Override
    public int hashCode() {
        return Objects.hash( virtualVolumeHostID,clusterID,visibleProtocolEndpointIDs,initiatorNames,hostAddress,callingVirtualVolumeHostID );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("virtualVolumeHostID", virtualVolumeHostID);
        map.put("clusterID", clusterID);
        map.put("visibleProtocolEndpointIDs", visibleProtocolEndpointIDs);
        map.put("initiatorNames", initiatorNames);
        map.put("hostAddress", hostAddress);
        map.put("callingVirtualVolumeHostID", callingVirtualVolumeHostID);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" virtualVolumeHostID : ").append(virtualVolumeHostID).append(",");
        if(null != clusterID && clusterID.isPresent()){
            sb.append(" clusterID : ").append(clusterID).append(",");
        }
        if(null != visibleProtocolEndpointIDs && visibleProtocolEndpointIDs.isPresent()){
            sb.append(" visibleProtocolEndpointIDs : ").append(visibleProtocolEndpointIDs).append(",");
        }
        if(null != initiatorNames && initiatorNames.isPresent()){
            sb.append(" initiatorNames : ").append(initiatorNames).append(",");
        }
        if(null != hostAddress && hostAddress.isPresent()){
            sb.append(" hostAddress : ").append(hostAddress).append(",");
        }
        if(null != callingVirtualVolumeHostID && callingVirtualVolumeHostID.isPresent()){
            sb.append(" callingVirtualVolumeHostID : ").append(callingVirtualVolumeHostID).append(",");
        }
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private java.util.UUID virtualVolumeHostID;
        private Optional<java.util.UUID> clusterID;
        private Optional<java.util.UUID[]> visibleProtocolEndpointIDs;
        private Optional<String[]> initiatorNames;
        private Optional<String> hostAddress;
        private Optional<java.util.UUID> callingVirtualVolumeHostID;

        private Builder() { }

        public ModifyVirtualVolumeHostRequest build() {
            return new ModifyVirtualVolumeHostRequest (
                         this.virtualVolumeHostID,
                         this.clusterID,
                         this.visibleProtocolEndpointIDs,
                         this.initiatorNames,
                         this.hostAddress,
                         this.callingVirtualVolumeHostID);
        }

        private ModifyVirtualVolumeHostRequest.Builder buildFrom(final ModifyVirtualVolumeHostRequest req) {
            this.virtualVolumeHostID = req.virtualVolumeHostID;
            this.clusterID = req.clusterID;
            this.visibleProtocolEndpointIDs = req.visibleProtocolEndpointIDs;
            this.initiatorNames = req.initiatorNames;
            this.hostAddress = req.hostAddress;
            this.callingVirtualVolumeHostID = req.callingVirtualVolumeHostID;

            return this;
        }

        public ModifyVirtualVolumeHostRequest.Builder virtualVolumeHostID(final java.util.UUID virtualVolumeHostID) {
            this.virtualVolumeHostID = virtualVolumeHostID;
            return this;
        }

        public ModifyVirtualVolumeHostRequest.Builder optionalClusterID(final java.util.UUID clusterID) {
            this.clusterID = (clusterID == null) ? Optional.<java.util.UUID>empty() : Optional.of(clusterID);
            return this;
        }

        public ModifyVirtualVolumeHostRequest.Builder optionalVisibleProtocolEndpointIDs(final java.util.UUID[] visibleProtocolEndpointIDs) {
            this.visibleProtocolEndpointIDs = (visibleProtocolEndpointIDs == null) ? Optional.<java.util.UUID[]>empty() : Optional.of(visibleProtocolEndpointIDs);
            return this;
        }

        public ModifyVirtualVolumeHostRequest.Builder optionalInitiatorNames(final String[] initiatorNames) {
            this.initiatorNames = (initiatorNames == null) ? Optional.<String[]>empty() : Optional.of(initiatorNames);
            return this;
        }

        public ModifyVirtualVolumeHostRequest.Builder optionalHostAddress(final String hostAddress) {
            this.hostAddress = (hostAddress == null) ? Optional.<String>empty() : Optional.of(hostAddress);
            return this;
        }

        public ModifyVirtualVolumeHostRequest.Builder optionalCallingVirtualVolumeHostID(final java.util.UUID callingVirtualVolumeHostID) {
            this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : Optional.of(callingVirtualVolumeHostID);
            return this;
        }

    }
}
