/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * ModifyVirtualVolumeMetadataRequest  
 * ModifyVirtualVolumeMetadata is used to selectively modify the VVol metadata.
 **/

public class ModifyVirtualVolumeMetadataRequest implements Serializable {

    public static final long serialVersionUID = -8162651590098912100L;
    @SerializedName("virtualVolumeID") private java.util.UUID virtualVolumeID;
    @SerializedName("metadata") private Attributes metadata;
    @SerializedName("removeKeys") private String[] removeKeys;
    @SerializedName("callingVirtualVolumeHostID") private Optional<java.util.UUID> callingVirtualVolumeHostID;

    // empty constructor
    @Since("7.0")
    public ModifyVirtualVolumeMetadataRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public ModifyVirtualVolumeMetadataRequest(
        java.util.UUID virtualVolumeID,
        Attributes metadata,
        String[] removeKeys,
        Optional<java.util.UUID> callingVirtualVolumeHostID
    )
    {
        this.virtualVolumeID = virtualVolumeID;
        this.metadata = metadata;
        this.removeKeys = removeKeys;
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    /** 
     * VvolVolumeID for the volume to be modified.
     **/
    public java.util.UUID getVirtualVolumeID() { return this.virtualVolumeID; }
    public void setVirtualVolumeID(java.util.UUID virtualVolumeID) { 
        this.virtualVolumeID = virtualVolumeID;
    }
    /** 
     * 
     **/
    public Attributes getMetadata() { return this.metadata; }
    public void setMetadata(Attributes metadata) { 
        this.metadata = metadata;
    }
    /** 
     * 
     **/
    public String[] getRemoveKeys() { return this.removeKeys; }
    public void setRemoveKeys(String[] removeKeys) { 
        this.removeKeys = removeKeys;
    }
    /** 
     * 
     **/
    public Optional<java.util.UUID> getCallingVirtualVolumeHostID() { return this.callingVirtualVolumeHostID; }
    public void setCallingVirtualVolumeHostID(Optional<java.util.UUID> callingVirtualVolumeHostID) { 
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        ModifyVirtualVolumeMetadataRequest that = (ModifyVirtualVolumeMetadataRequest) o;

        return 
            Objects.equals(virtualVolumeID, that.virtualVolumeID) && 
            Objects.equals(metadata, that.metadata) && 
            Arrays.equals(removeKeys, that.removeKeys) && 
            Objects.equals(callingVirtualVolumeHostID, that.callingVirtualVolumeHostID);
    }

    @Override
    public int hashCode() {
        return Objects.hash( virtualVolumeID,metadata,(Object[])removeKeys,callingVirtualVolumeHostID );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("virtualVolumeID", virtualVolumeID);
        map.put("metadata", metadata);
        map.put("removeKeys", removeKeys);
        map.put("callingVirtualVolumeHostID", callingVirtualVolumeHostID);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" virtualVolumeID : ").append(virtualVolumeID).append(",");
        sb.append(" metadata : ").append(metadata).append(",");
        sb.append(" removeKeys : ").append(Arrays.toString(removeKeys)).append(",");
        if(null != callingVirtualVolumeHostID && callingVirtualVolumeHostID.isPresent()){
            sb.append(" callingVirtualVolumeHostID : ").append(callingVirtualVolumeHostID).append(",");
        }
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private java.util.UUID virtualVolumeID;
        private Attributes metadata;
        private String[] removeKeys;
        private Optional<java.util.UUID> callingVirtualVolumeHostID;

        private Builder() { }

        public ModifyVirtualVolumeMetadataRequest build() {
            return new ModifyVirtualVolumeMetadataRequest (
                         this.virtualVolumeID,
                         this.metadata,
                         this.removeKeys,
                         this.callingVirtualVolumeHostID);
        }

        private ModifyVirtualVolumeMetadataRequest.Builder buildFrom(final ModifyVirtualVolumeMetadataRequest req) {
            this.virtualVolumeID = req.virtualVolumeID;
            this.metadata = req.metadata;
            this.removeKeys = req.removeKeys;
            this.callingVirtualVolumeHostID = req.callingVirtualVolumeHostID;

            return this;
        }

        public ModifyVirtualVolumeMetadataRequest.Builder virtualVolumeID(final java.util.UUID virtualVolumeID) {
            this.virtualVolumeID = virtualVolumeID;
            return this;
        }

        public ModifyVirtualVolumeMetadataRequest.Builder metadata(final Attributes metadata) {
            this.metadata = metadata;
            return this;
        }

        public ModifyVirtualVolumeMetadataRequest.Builder removeKeys(final String[] removeKeys) {
            this.removeKeys = removeKeys;
            return this;
        }

        public ModifyVirtualVolumeMetadataRequest.Builder optionalCallingVirtualVolumeHostID(final java.util.UUID callingVirtualVolumeHostID) {
            this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : Optional.of(callingVirtualVolumeHostID);
            return this;
        }

    }
}
