/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * QueryVirtualVolumeMetadataRequest  
 * QueryVirtualVolumeMetadata returns a list of VVols matching a metadata query.
 **/

public class QueryVirtualVolumeMetadataRequest implements Serializable {

    public static final long serialVersionUID = -6565918220370427380L;
    @SerializedName("queryConstraints") private Optional<Attributes> queryConstraints;
    @SerializedName("wildcardConstraints") private Optional<String[]> wildcardConstraints;
    @SerializedName("callingVirtualVolumeHostID") private Optional<java.util.UUID> callingVirtualVolumeHostID;

    // empty constructor
    @Since("7.0")
    public QueryVirtualVolumeMetadataRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public QueryVirtualVolumeMetadataRequest(
        Optional<Attributes> queryConstraints,
        Optional<String[]> wildcardConstraints,
        Optional<java.util.UUID> callingVirtualVolumeHostID
    )
    {
        this.queryConstraints = (queryConstraints == null) ? Optional.<Attributes>empty() : queryConstraints;
        this.wildcardConstraints = (wildcardConstraints == null) ? Optional.<String[]>empty() : wildcardConstraints;
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    /** 
     * 
     **/
    public Optional<Attributes> getQueryConstraints() { return this.queryConstraints; }
    public void setQueryConstraints(Optional<Attributes> queryConstraints) { 
        this.queryConstraints = (queryConstraints == null) ? Optional.<Attributes>empty() : queryConstraints;
    }
    /** 
     * 
     **/
    public Optional<String[]> getWildcardConstraints() { return this.wildcardConstraints; }
    public void setWildcardConstraints(Optional<String[]> wildcardConstraints) { 
        this.wildcardConstraints = (wildcardConstraints == null) ? Optional.<String[]>empty() : wildcardConstraints;
    }
    /** 
     * 
     **/
    public Optional<java.util.UUID> getCallingVirtualVolumeHostID() { return this.callingVirtualVolumeHostID; }
    public void setCallingVirtualVolumeHostID(Optional<java.util.UUID> callingVirtualVolumeHostID) { 
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        QueryVirtualVolumeMetadataRequest that = (QueryVirtualVolumeMetadataRequest) o;

        return 
            Objects.equals(queryConstraints, that.queryConstraints) && 
            Objects.equals(wildcardConstraints, that.wildcardConstraints) && 
            Objects.equals(callingVirtualVolumeHostID, that.callingVirtualVolumeHostID);
    }

    @Override
    public int hashCode() {
        return Objects.hash( queryConstraints,wildcardConstraints,callingVirtualVolumeHostID );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("queryConstraints", queryConstraints);
        map.put("wildcardConstraints", wildcardConstraints);
        map.put("callingVirtualVolumeHostID", callingVirtualVolumeHostID);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        if(null != queryConstraints && queryConstraints.isPresent()){
            sb.append(" queryConstraints : ").append(queryConstraints).append(",");
        }
        if(null != wildcardConstraints && wildcardConstraints.isPresent()){
            sb.append(" wildcardConstraints : ").append(wildcardConstraints).append(",");
        }
        if(null != callingVirtualVolumeHostID && callingVirtualVolumeHostID.isPresent()){
            sb.append(" callingVirtualVolumeHostID : ").append(callingVirtualVolumeHostID).append(",");
        }
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private Optional<Attributes> queryConstraints;
        private Optional<String[]> wildcardConstraints;
        private Optional<java.util.UUID> callingVirtualVolumeHostID;

        private Builder() { }

        public QueryVirtualVolumeMetadataRequest build() {
            return new QueryVirtualVolumeMetadataRequest (
                         this.queryConstraints,
                         this.wildcardConstraints,
                         this.callingVirtualVolumeHostID);
        }

        private QueryVirtualVolumeMetadataRequest.Builder buildFrom(final QueryVirtualVolumeMetadataRequest req) {
            this.queryConstraints = req.queryConstraints;
            this.wildcardConstraints = req.wildcardConstraints;
            this.callingVirtualVolumeHostID = req.callingVirtualVolumeHostID;

            return this;
        }

        public QueryVirtualVolumeMetadataRequest.Builder optionalQueryConstraints(final Attributes queryConstraints) {
            this.queryConstraints = (queryConstraints == null) ? Optional.<Attributes>empty() : Optional.of(queryConstraints);
            return this;
        }

        public QueryVirtualVolumeMetadataRequest.Builder optionalWildcardConstraints(final String[] wildcardConstraints) {
            this.wildcardConstraints = (wildcardConstraints == null) ? Optional.<String[]>empty() : Optional.of(wildcardConstraints);
            return this;
        }

        public QueryVirtualVolumeMetadataRequest.Builder optionalCallingVirtualVolumeHostID(final java.util.UUID callingVirtualVolumeHostID) {
            this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : Optional.of(callingVirtualVolumeHostID);
            return this;
        }

    }
}
