/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * RollbackVirtualVolumeRequest  
 * RollbackVirtualVolume is used to restore a VMware Virtual Volume snapshot.
 **/

public class RollbackVirtualVolumeRequest implements Serializable {

    public static final long serialVersionUID = -6436858086883537017L;
    @SerializedName("srcVirtualVolumeID") private java.util.UUID srcVirtualVolumeID;
    @SerializedName("dstVirtualVolumeID") private java.util.UUID dstVirtualVolumeID;
    @SerializedName("callingVirtualVolumeHostID") private Optional<java.util.UUID> callingVirtualVolumeHostID;

    // empty constructor
    @Since("7.0")
    public RollbackVirtualVolumeRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public RollbackVirtualVolumeRequest(
        java.util.UUID srcVirtualVolumeID,
        java.util.UUID dstVirtualVolumeID,
        Optional<java.util.UUID> callingVirtualVolumeHostID
    )
    {
        this.srcVirtualVolumeID = srcVirtualVolumeID;
        this.dstVirtualVolumeID = dstVirtualVolumeID;
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    /** 
     * The ID of the Virtual Volume snapshot.
     **/
    public java.util.UUID getSrcVirtualVolumeID() { return this.srcVirtualVolumeID; }
    public void setSrcVirtualVolumeID(java.util.UUID srcVirtualVolumeID) { 
        this.srcVirtualVolumeID = srcVirtualVolumeID;
    }
    /** 
     * The ID of the Virtual Volume to restore to.
     **/
    public java.util.UUID getDstVirtualVolumeID() { return this.dstVirtualVolumeID; }
    public void setDstVirtualVolumeID(java.util.UUID dstVirtualVolumeID) { 
        this.dstVirtualVolumeID = dstVirtualVolumeID;
    }
    /** 
     * 
     **/
    public Optional<java.util.UUID> getCallingVirtualVolumeHostID() { return this.callingVirtualVolumeHostID; }
    public void setCallingVirtualVolumeHostID(Optional<java.util.UUID> callingVirtualVolumeHostID) { 
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        RollbackVirtualVolumeRequest that = (RollbackVirtualVolumeRequest) o;

        return 
            Objects.equals(srcVirtualVolumeID, that.srcVirtualVolumeID) && 
            Objects.equals(dstVirtualVolumeID, that.dstVirtualVolumeID) && 
            Objects.equals(callingVirtualVolumeHostID, that.callingVirtualVolumeHostID);
    }

    @Override
    public int hashCode() {
        return Objects.hash( srcVirtualVolumeID,dstVirtualVolumeID,callingVirtualVolumeHostID );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("srcVirtualVolumeID", srcVirtualVolumeID);
        map.put("dstVirtualVolumeID", dstVirtualVolumeID);
        map.put("callingVirtualVolumeHostID", callingVirtualVolumeHostID);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" srcVirtualVolumeID : ").append(srcVirtualVolumeID).append(",");
        sb.append(" dstVirtualVolumeID : ").append(dstVirtualVolumeID).append(",");
        if(null != callingVirtualVolumeHostID && callingVirtualVolumeHostID.isPresent()){
            sb.append(" callingVirtualVolumeHostID : ").append(callingVirtualVolumeHostID).append(",");
        }
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private java.util.UUID srcVirtualVolumeID;
        private java.util.UUID dstVirtualVolumeID;
        private Optional<java.util.UUID> callingVirtualVolumeHostID;

        private Builder() { }

        public RollbackVirtualVolumeRequest build() {
            return new RollbackVirtualVolumeRequest (
                         this.srcVirtualVolumeID,
                         this.dstVirtualVolumeID,
                         this.callingVirtualVolumeHostID);
        }

        private RollbackVirtualVolumeRequest.Builder buildFrom(final RollbackVirtualVolumeRequest req) {
            this.srcVirtualVolumeID = req.srcVirtualVolumeID;
            this.dstVirtualVolumeID = req.dstVirtualVolumeID;
            this.callingVirtualVolumeHostID = req.callingVirtualVolumeHostID;

            return this;
        }

        public RollbackVirtualVolumeRequest.Builder srcVirtualVolumeID(final java.util.UUID srcVirtualVolumeID) {
            this.srcVirtualVolumeID = srcVirtualVolumeID;
            return this;
        }

        public RollbackVirtualVolumeRequest.Builder dstVirtualVolumeID(final java.util.UUID dstVirtualVolumeID) {
            this.dstVirtualVolumeID = dstVirtualVolumeID;
            return this;
        }

        public RollbackVirtualVolumeRequest.Builder optionalCallingVirtualVolumeHostID(final java.util.UUID callingVirtualVolumeHostID) {
            this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : Optional.of(callingVirtualVolumeHostID);
            return this;
        }

    }
}
