/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * SnapshotVirtualVolumeRequest  
 * SnapshotVirtualVolume is used to take a VMware Virtual Volume snapshot.
 **/

public class SnapshotVirtualVolumeRequest implements Serializable {

    public static final long serialVersionUID = 7175418810706954782L;
    @SerializedName("virtualVolumeID") private java.util.UUID virtualVolumeID;
    @SerializedName("timeout") private Long timeout;
    @SerializedName("metadata") private Optional<Attributes> metadata;
    @SerializedName("callingVirtualVolumeHostID") private Optional<java.util.UUID> callingVirtualVolumeHostID;

    // empty constructor
    @Since("7.0")
    public SnapshotVirtualVolumeRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public SnapshotVirtualVolumeRequest(
        java.util.UUID virtualVolumeID,
        Long timeout,
        Optional<Attributes> metadata,
        Optional<java.util.UUID> callingVirtualVolumeHostID
    )
    {
        this.virtualVolumeID = virtualVolumeID;
        this.timeout = timeout;
        this.metadata = (metadata == null) ? Optional.<Attributes>empty() : metadata;
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    /** 
     * The ID of the Virtual Volume to clone.
     **/
    public java.util.UUID getVirtualVolumeID() { return this.virtualVolumeID; }
    public void setVirtualVolumeID(java.util.UUID virtualVolumeID) { 
        this.virtualVolumeID = virtualVolumeID;
    }
    /** 
     * Number of seconds to complete or fail.
     **/
    public Long getTimeout() { return this.timeout; }
    public void setTimeout(Long timeout) { 
        this.timeout = timeout;
    }
    /** 
     * 
     **/
    public Optional<Attributes> getMetadata() { return this.metadata; }
    public void setMetadata(Optional<Attributes> metadata) { 
        this.metadata = (metadata == null) ? Optional.<Attributes>empty() : metadata;
    }
    /** 
     * 
     **/
    public Optional<java.util.UUID> getCallingVirtualVolumeHostID() { return this.callingVirtualVolumeHostID; }
    public void setCallingVirtualVolumeHostID(Optional<java.util.UUID> callingVirtualVolumeHostID) { 
        this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : callingVirtualVolumeHostID;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        SnapshotVirtualVolumeRequest that = (SnapshotVirtualVolumeRequest) o;

        return 
            Objects.equals(virtualVolumeID, that.virtualVolumeID) && 
            Objects.equals(timeout, that.timeout) && 
            Objects.equals(metadata, that.metadata) && 
            Objects.equals(callingVirtualVolumeHostID, that.callingVirtualVolumeHostID);
    }

    @Override
    public int hashCode() {
        return Objects.hash( virtualVolumeID,timeout,metadata,callingVirtualVolumeHostID );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("virtualVolumeID", virtualVolumeID);
        map.put("timeout", timeout);
        map.put("metadata", metadata);
        map.put("callingVirtualVolumeHostID", callingVirtualVolumeHostID);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" virtualVolumeID : ").append(virtualVolumeID).append(",");
        sb.append(" timeout : ").append(timeout).append(",");
        if(null != metadata && metadata.isPresent()){
            sb.append(" metadata : ").append(metadata).append(",");
        }
        if(null != callingVirtualVolumeHostID && callingVirtualVolumeHostID.isPresent()){
            sb.append(" callingVirtualVolumeHostID : ").append(callingVirtualVolumeHostID).append(",");
        }
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private java.util.UUID virtualVolumeID;
        private Long timeout;
        private Optional<Attributes> metadata;
        private Optional<java.util.UUID> callingVirtualVolumeHostID;

        private Builder() { }

        public SnapshotVirtualVolumeRequest build() {
            return new SnapshotVirtualVolumeRequest (
                         this.virtualVolumeID,
                         this.timeout,
                         this.metadata,
                         this.callingVirtualVolumeHostID);
        }

        private SnapshotVirtualVolumeRequest.Builder buildFrom(final SnapshotVirtualVolumeRequest req) {
            this.virtualVolumeID = req.virtualVolumeID;
            this.timeout = req.timeout;
            this.metadata = req.metadata;
            this.callingVirtualVolumeHostID = req.callingVirtualVolumeHostID;

            return this;
        }

        public SnapshotVirtualVolumeRequest.Builder virtualVolumeID(final java.util.UUID virtualVolumeID) {
            this.virtualVolumeID = virtualVolumeID;
            return this;
        }

        public SnapshotVirtualVolumeRequest.Builder timeout(final Long timeout) {
            this.timeout = timeout;
            return this;
        }

        public SnapshotVirtualVolumeRequest.Builder optionalMetadata(final Attributes metadata) {
            this.metadata = (metadata == null) ? Optional.<Attributes>empty() : Optional.of(metadata);
            return this;
        }

        public SnapshotVirtualVolumeRequest.Builder optionalCallingVirtualVolumeHostID(final java.util.UUID callingVirtualVolumeHostID) {
            this.callingVirtualVolumeHostID = (callingVirtualVolumeHostID == null) ? Optional.<java.util.UUID>empty() : Optional.of(callingVirtualVolumeHostID);
            return this;
        }

    }
}
