/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * UnbindVirtualVolumesRequest  
 * UnbindGetVirtualVolume removes the VVol <-> Host binding.
 **/

public class UnbindVirtualVolumesRequest implements Serializable {

    public static final long serialVersionUID = 6419761508672473L;
    @SerializedName("unbindContext") private String unbindContext;
    @SerializedName("virtualVolumeHostID") private java.util.UUID virtualVolumeHostID;
    @SerializedName("unbindArgs") private UnbindArguments[] unbindArgs;

    // empty constructor
    @Since("7.0")
    public UnbindVirtualVolumesRequest() {}

    
    // parameterized constructor
    @Since("7.0")
    public UnbindVirtualVolumesRequest(
        String unbindContext,
        java.util.UUID virtualVolumeHostID,
        UnbindArguments[] unbindArgs
    )
    {
        this.unbindContext = unbindContext;
        this.virtualVolumeHostID = virtualVolumeHostID;
        this.unbindArgs = unbindArgs;
    }

    /** 
     * Normal, Start, or End?
     **/
    public String getUnbindContext() { return this.unbindContext; }
    public void setUnbindContext(String unbindContext) { 
        this.unbindContext = unbindContext;
    }
    /** 
     * UnbindGetVirtualVolume removes the VVol <-> Host binding.
     **/
    public java.util.UUID getVirtualVolumeHostID() { return this.virtualVolumeHostID; }
    public void setVirtualVolumeHostID(java.util.UUID virtualVolumeHostID) { 
        this.virtualVolumeHostID = virtualVolumeHostID;
    }
    /** 
     * UnbindGetVirtualVolume removes the VVol <-> Host binding.
     **/
    public UnbindArguments[] getUnbindArgs() { return this.unbindArgs; }
    public void setUnbindArgs(UnbindArguments[] unbindArgs) { 
        this.unbindArgs = unbindArgs;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        UnbindVirtualVolumesRequest that = (UnbindVirtualVolumesRequest) o;

        return 
            Objects.equals(unbindContext, that.unbindContext) && 
            Objects.equals(virtualVolumeHostID, that.virtualVolumeHostID) && 
            Arrays.equals(unbindArgs, that.unbindArgs);
    }

    @Override
    public int hashCode() {
        return Objects.hash( unbindContext,virtualVolumeHostID,(Object[])unbindArgs );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("unbindContext", unbindContext);
        map.put("virtualVolumeHostID", virtualVolumeHostID);
        map.put("unbindArgs", unbindArgs);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" unbindContext : ").append(unbindContext).append(",");
        sb.append(" virtualVolumeHostID : ").append(virtualVolumeHostID).append(",");
        sb.append(" unbindArgs : ").append(Arrays.toString(unbindArgs)).append(",");
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private String unbindContext;
        private java.util.UUID virtualVolumeHostID;
        private UnbindArguments[] unbindArgs;

        private Builder() { }

        public UnbindVirtualVolumesRequest build() {
            return new UnbindVirtualVolumesRequest (
                         this.unbindContext,
                         this.virtualVolumeHostID,
                         this.unbindArgs);
        }

        private UnbindVirtualVolumesRequest.Builder buildFrom(final UnbindVirtualVolumesRequest req) {
            this.unbindContext = req.unbindContext;
            this.virtualVolumeHostID = req.virtualVolumeHostID;
            this.unbindArgs = req.unbindArgs;

            return this;
        }

        public UnbindVirtualVolumesRequest.Builder unbindContext(final String unbindContext) {
            this.unbindContext = unbindContext;
            return this;
        }

        public UnbindVirtualVolumesRequest.Builder virtualVolumeHostID(final java.util.UUID virtualVolumeHostID) {
            this.virtualVolumeHostID = virtualVolumeHostID;
            return this;
        }

        public UnbindVirtualVolumesRequest.Builder unbindArgs(final UnbindArguments[] unbindArgs) {
            this.unbindArgs = unbindArgs;
            return this;
        }

    }
}
