/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * VasaProviderInfo  
 **/

public class VasaProviderInfo implements Serializable {

    public static final long serialVersionUID = 5903091203357358890L;
    @SerializedName("keystore") private String keystore;
    @SerializedName("controlPort") private Long controlPort;
    @SerializedName("vasaProviderID") private java.util.UUID vasaProviderID;
    @SerializedName("options") private Attributes options;

    // empty constructor
    @Since("7.0")
    public VasaProviderInfo() {}

    
    // parameterized constructor
    @Since("7.0")
    public VasaProviderInfo(
        String keystore,
        Long controlPort,
        java.util.UUID vasaProviderID,
        Attributes options
    )
    {
        this.keystore = keystore;
        this.controlPort = controlPort;
        this.vasaProviderID = vasaProviderID;
        this.options = options;
    }

    /** 
     * 
     **/
    public String getKeystore() { return this.keystore; }
    public void setKeystore(String keystore) { 
        this.keystore = keystore;
    }
    /** 
     * 
     **/
    public Long getControlPort() { return this.controlPort; }
    public void setControlPort(Long controlPort) { 
        this.controlPort = controlPort;
    }
    /** 
     * 
     **/
    public java.util.UUID getVasaProviderID() { return this.vasaProviderID; }
    public void setVasaProviderID(java.util.UUID vasaProviderID) { 
        this.vasaProviderID = vasaProviderID;
    }
    /** 
     * 
     **/
    public Attributes getOptions() { return this.options; }
    public void setOptions(Attributes options) { 
        this.options = options;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        VasaProviderInfo that = (VasaProviderInfo) o;

        return 
            Objects.equals(keystore, that.keystore) && 
            Objects.equals(controlPort, that.controlPort) && 
            Objects.equals(vasaProviderID, that.vasaProviderID) && 
            Objects.equals(options, that.options);
    }

    @Override
    public int hashCode() {
        return Objects.hash( keystore,controlPort,vasaProviderID,options );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("keystore", keystore);
        map.put("controlPort", controlPort);
        map.put("vasaProviderID", vasaProviderID);
        map.put("options", options);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" keystore : ").append(keystore).append(",");
        sb.append(" controlPort : ").append(controlPort).append(",");
        sb.append(" vasaProviderID : ").append(vasaProviderID).append(",");
        sb.append(" options : ").append(options).append(",");
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private String keystore;
        private Long controlPort;
        private java.util.UUID vasaProviderID;
        private Attributes options;

        private Builder() { }

        public VasaProviderInfo build() {
            return new VasaProviderInfo (
                         this.keystore,
                         this.controlPort,
                         this.vasaProviderID,
                         this.options);
        }

        private VasaProviderInfo.Builder buildFrom(final VasaProviderInfo req) {
            this.keystore = req.keystore;
            this.controlPort = req.controlPort;
            this.vasaProviderID = req.vasaProviderID;
            this.options = req.options;

            return this;
        }

        public VasaProviderInfo.Builder keystore(final String keystore) {
            this.keystore = keystore;
            return this;
        }

        public VasaProviderInfo.Builder controlPort(final Long controlPort) {
            this.controlPort = controlPort;
            return this;
        }

        public VasaProviderInfo.Builder vasaProviderID(final java.util.UUID vasaProviderID) {
            this.vasaProviderID = vasaProviderID;
            return this;
        }

        public VasaProviderInfo.Builder options(final Attributes options) {
            this.options = options;
            return this;
        }

    }
}
