/*
 * Copyright &copy 2014-2016 NetApp, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * DO NOT EDIT THIS CODE BY HAND! It has been generated with jsvcgen.
 */
package com.solidfire.element.api;

import com.solidfire.core.client.Attributes;
import com.solidfire.gson.annotations.SerializedName;
import com.solidfire.core.annotation.Since;
import com.solidfire.core.javautil.Optional;
import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Objects;

/**
 * VirtualVolumeBitmapResult  
 **/

public class VirtualVolumeBitmapResult implements Serializable {

    public static final long serialVersionUID = 6018449505082956163L;
    @SerializedName("bitmap") private String bitmap;
    @SerializedName("segmentLength") private Long segmentLength;

    // empty constructor
    @Since("7.0")
    public VirtualVolumeBitmapResult() {}

    
    // parameterized constructor
    @Since("7.0")
    public VirtualVolumeBitmapResult(
        String bitmap,
        Long segmentLength
    )
    {
        this.bitmap = bitmap;
        this.segmentLength = segmentLength;
    }

    /** 
     * The b64 bitmap.
     **/
    public String getBitmap() { return this.bitmap; }
    public void setBitmap(String bitmap) { 
        this.bitmap = bitmap;
    }
    /** 
     * Byte length, adjusted to end on a chunk boundary.
     **/
    public Long getSegmentLength() { return this.segmentLength; }
    public void setSegmentLength(Long segmentLength) { 
        this.segmentLength = segmentLength;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        VirtualVolumeBitmapResult that = (VirtualVolumeBitmapResult) o;

        return 
            Objects.equals(bitmap, that.bitmap) && 
            Objects.equals(segmentLength, that.segmentLength);
    }

    @Override
    public int hashCode() {
        return Objects.hash( bitmap,segmentLength );
    }


    public java.util.Map<String, Object> toMap() {
        java.util.Map<String, Object> map = new HashMap<>();
        map.put("bitmap", bitmap);
        map.put("segmentLength", segmentLength);
        return map;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append( "{ " );

        sb.append(" bitmap : ").append(bitmap).append(",");
        sb.append(" segmentLength : ").append(segmentLength).append(",");
        sb.append( " }" );

        if(sb.lastIndexOf(", }") != -1)
            sb.deleteCharAt(sb.lastIndexOf(", }"));

        return sb.toString();
    }

    public static Builder builder() {
        return new Builder();
    }

    public final Builder asBuilder() {
        return new Builder().buildFrom(this);
    }

    public static class Builder {
        private String bitmap;
        private Long segmentLength;

        private Builder() { }

        public VirtualVolumeBitmapResult build() {
            return new VirtualVolumeBitmapResult (
                         this.bitmap,
                         this.segmentLength);
        }

        private VirtualVolumeBitmapResult.Builder buildFrom(final VirtualVolumeBitmapResult req) {
            this.bitmap = req.bitmap;
            this.segmentLength = req.segmentLength;

            return this;
        }

        public VirtualVolumeBitmapResult.Builder bitmap(final String bitmap) {
            this.bitmap = bitmap;
            return this;
        }

        public VirtualVolumeBitmapResult.Builder segmentLength(final Long segmentLength) {
            this.segmentLength = segmentLength;
            return this;
        }

    }
}
